package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;
import org.hibernate.annotations.ColumnDefault;

import javax.persistence.*;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

@Entity
@Table(name = "materials")
@Data
@RequiredArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class Material extends BeanModel implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private Integer materialID = 0;

    @NonNull
    @NotNull
    @NotEmpty
    @Column(unique = true)
    private String materialCode;

    @NonNull
    @NotNull
    @ColumnDefault("0")
    private float inventoryQuantity;

    @NonNull
    @NotNull
    @ColumnDefault("false")
    private boolean isMixType;

    @NonNull
    @NotNull
    @ManyToOne
    private MaterialType materialType;

    @Override
    public Integer getID() {
        return materialID;
    }

    public boolean isMixType() {
        return isMixType;
    }

}
