package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;
import org.hibernate.annotations.ColumnDefault;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

@Entity
@Data
@EqualsAndHashCode(callSuper = false)
@RequiredArgsConstructor
@NoArgsConstructor
public class MaterialType extends BeanModel implements Serializable {

    public static final String DEFAULT_MATERIAL_TYPE_NAME = "Aucun";
    public static final String BASE_MATERIAL_TYPE_NAME = "Base";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private Integer materialTypeID;

    @NonNull
    @NotNull
    @Column(unique = true)
    private String materialTypeName;

    @NonNull
    @NotNull
    @Column(unique = true)
    private String prefix;

    @NonNull
    @NotNull
    @ColumnDefault("false")
    private Boolean usePercentages;

    @OneToMany
    @JoinColumn(name = "material_type")
    private List<Material> materials;

    @Override
    public Integer getID() {
        return materialTypeID;
    }
}
