package dev.fyloz.trial.colorrecipesexplorer.core.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.*;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

@Entity
@Table(name = "mixQuantities")
@Data
@EqualsAndHashCode(callSuper = false)
@RequiredArgsConstructor
@NoArgsConstructor
public class MixQuantity extends BeanModel implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Basic
    private Integer mixQuantityID = 0;

    @NonNull
    @ToString.Exclude
    @NotNull
    @JsonIgnore
    @ManyToOne
    private Mix mix;

    @NonNull
    @NotNull
    @ManyToOne
    private Material material;

    @NonNull
    @NotNull
    private Float quantity;

    @Override
    public Integer getID() {
        return mixQuantityID;
    }
}
