package dev.fyloz.trial.colorrecipesexplorer.dao;

import dev.fyloz.trial.colorrecipesexplorer.core.model.Material;
import dev.fyloz.trial.colorrecipesexplorer.core.model.MaterialType;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface MaterialDao extends JpaRepository<Material, Integer> {
    Optional<Material> findByMaterialCode(String materialCode);

    List<Material> findAllByMaterialType(MaterialType materialType);

    List<Material> findAllByMaterialCodeContainingIgnoreCase(String stringSearch);

    boolean existsByMaterialCode(String materialCode);
}
