(() => {
    document.querySelectorAll(".recipeRow").forEach(e => {
        if (e.dataset.approbationdate === undefined) {
            e.classList.add("unapproved");
            e.title = recipeNotApproved;
        }
    });
})();

function closeTabs() {
    document.querySelectorAll(".recipesList").forEach(l => l.style.display = "none");
}

function openTabs() {
    document.querySelectorAll(".recipesList").forEach(l => l.style.display = "");
}

const companyRows = document.querySelectorAll(".companyTab");

function performSearch(searchString) {
    let found = false;
    let emptySearch = false;

    const recipesContainer = document.querySelector(".recipesContainer:not(.researchEnabled)");
    if (recipesContainer !== undefined && recipesContainer !== null) {
        recipesContainer.classList.add("researchEnabled");
    }

    document.querySelectorAll(".researchResult").forEach(t => {
        t.classList.remove("researchResult");
    });

    companyRows.forEach(c => {
            const recipeRows = c.querySelectorAll(".recipeRow");

            hideElement(warningMsgBox);

            if (!searchString || !searchString.replace(/\s/g, '').length) {
                c.classList.add("researchResult");

                recipeRows.forEach(r => {
                    r.classList.add("researchResult");
                });

                found = true;
                emptySearch = true;
            } else if (searchIn(searchString, c.querySelector("h2").dataset.companyname)) {
                c.classList.add("researchResult");
                recipeRows.forEach(r => r.classList.add("researchResult"));
                found = true;
            } else {
                recipeRows.forEach(r => {
                    r.querySelectorAll(".descriptionCell").forEach(d => {
                        if (searchIn(searchString, d.textContent)) {
                            r.classList.add("researchResult");
                            c.classList.add("researchResult");
                            found = true;
                        }
                    });
                });
            }

            if (!found) {
                warningMsgBoxText.innerText = researchNotFound;
                showElement(warningMsgBox);
            }

            if (emptySearch) closeTabs();
            else openTabs();
        }
    );
}
